#include <glib.h>

enum observer_status
{
  OBSERVER_STATUS_OK = 0,
  OBSERVER_STATUS_ERROR = 1,
  OBSERVER_STATUS_CANCEL = 2,
  OBSERVER_STATUS_ABORTED = 3
};

typedef gboolean (*obsever_cb)(enum observer_type type, enum observer_status status, gprs_private *private, gpointer user_data);

gboolean register_observer(enum observer_type type, obsever_cb cb, gprs_private *priv, gpointer user_data, gpointer observer_token);
gboolean abort_observation(obsever_cb cb, gprs_private *priv, gpointer observer_token);
gboolean mark_observer_active(gprs_private *priv, enum observer_type type);
gboolean notify_observers(enum observer_type type, enum observer_status status, gprs_private *priv);
